import 'package:flutter_rosutils/flutter_rosutils.dart';

class CommandMessage extends RosMessage {
  int command;
  static const INITIALIZE_ALL = 0;
  static const SHUTDOWN = 10;
  static const START_GAME = 20;

  CommandMessage._(this.command);
  factory CommandMessage(dynamic message) {
    return CommandMessage._(message['msg']['command']);
  }

  CommandMessage.initialize() {
    command = INITIALIZE_ALL;
  }

  CommandMessage.shutdown() {
    command = SHUTDOWN;
  }

  CommandMessage.startGame() {
    command = START_GAME;
  }

  @override
  dynamic get serializedMessage => {'command': command};
}

class ExampleBloc {
  Ros _ros;
  RosMessageTopic<CommandMessage> messageTopic;

  ExampleBloc() {
    _ros = Ros(url: 'ws://127.0.0.1:9090');
    messageTopic = RosMessageTopic<CommandMessage>(ros: _ros, name: 'command', type: 'custom_msgs/CommandMessage');
  }

  void sendInitMessage() {
    messageTopic.value = CommandMessage.initialize();
  }
}
